// ##### ENDFILE "BooleanFormValueWrap.h"


// ##### BEGINFILE "RangedIntegerFormValueWrap.h"
/** @file
 * VirtualBox API class wrapper header for IRangedIntegerFormValue.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/*
 * Copyright (C) 2010-2020 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#ifndef RangedIntegerFormValueWrap_H_
#define RangedIntegerFormValueWrap_H_
#ifndef RT_WITHOUT_PRAGMA_ONCE
# pragma once
#endif

#include "VirtualBoxBase.h"
#include "Wrapper.h"

class ATL_NO_VTABLE RangedIntegerFormValueWrap
    : public VirtualBoxBase
    , VBOX_SCRIPTABLE_IMPL(IRangedIntegerFormValue)
{
    Q_OBJECT

public:
    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT(RangedIntegerFormValueWrap, IRangedIntegerFormValue)
    DECLARE_NOT_AGGREGATABLE(RangedIntegerFormValueWrap)
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(RangedIntegerFormValueWrap)
        COM_INTERFACE_ENTRY(ISupportErrorInfo)
        COM_INTERFACE_ENTRY(IRangedIntegerFormValue)
        COM_INTERFACE_ENTRY(IFormValue)
        COM_INTERFACE_ENTRY2(IDispatch, IRangedIntegerFormValue)
        VBOX_TWEAK_INTERFACE_ENTRY(IRangedIntegerFormValue)
    END_COM_MAP()

    DECLARE_EMPTY_CTOR_DTOR(RangedIntegerFormValueWrap)

    /** @name Public IFormValue properties
     * @{ */
    STDMETHOD(COMGETTER(Type))(FormValueType_T *aType);
    STDMETHOD(COMGETTER(Generation))(LONG *aGeneration);
    STDMETHOD(COMGETTER(Enabled))(BOOL *aEnabled);
    STDMETHOD(COMGETTER(Visible))(BOOL *aVisible);
    STDMETHOD(COMGETTER(Label))(BSTR *aLabel);
    STDMETHOD(COMGETTER(Description))(BSTR *aDescription);
    STDMETHOD(COMGETTER(Help))(BSTR *aHelp);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute1IFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute2IFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute3IFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute4IFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute5IFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute6IFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute7IFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute8IFormValue))(ULONG *aReserved);
    /** @} */

    /** @name Public IRangedIntegerFormValue properties
     * @{ */
    STDMETHOD(COMGETTER(Suffix))(BSTR *aSuffix);
    STDMETHOD(COMGETTER(Minimum))(LONG *aMinimum);
    STDMETHOD(COMGETTER(Maximum))(LONG *aMaximum);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute1IRangedIntegerFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute2IRangedIntegerFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute3IRangedIntegerFormValue))(ULONG *aReserved);
    STDMETHOD(COMGETTER(InternalAndReservedAttribute4IRangedIntegerFormValue))(ULONG *aReserved);
    /** @} */

    /** @name Public IFormValue methods
     * @{ */
    STDMETHOD(InternalAndReservedMethod1IFormValue)();
    STDMETHOD(InternalAndReservedMethod2IFormValue)();
    STDMETHOD(InternalAndReservedMethod3IFormValue)();
    STDMETHOD(InternalAndReservedMethod4IFormValue)();
    /** @} */

    /** @name Public IRangedIntegerFormValue methods
     * @{ */
    STDMETHOD(GetInteger)(LONG *aValue);
    STDMETHOD(SetInteger)(LONG aValue,
                          IProgress **aProgress);
    STDMETHOD(InternalAndReservedMethod1IRangedIntegerFormValue)();
    STDMETHOD(InternalAndReservedMethod2IRangedIntegerFormValue)();
    STDMETHOD(InternalAndReservedMethod3IRangedIntegerFormValue)();
    STDMETHOD(InternalAndReservedMethod4IRangedIntegerFormValue)();
    /** @} */

private:
    /** @name Wrapped IFormValue properties
     * @{ */
    virtual HRESULT getType(FormValueType_T *aType) = 0;
    virtual HRESULT getGeneration(LONG *aGeneration) = 0;
    virtual HRESULT getEnabled(BOOL *aEnabled) = 0;
    virtual HRESULT getVisible(BOOL *aVisible) = 0;
    virtual HRESULT getLabel(com::Utf8Str &aLabel) = 0;
    virtual HRESULT getDescription(com::Utf8Str &aDescription) = 0;
    virtual HRESULT getHelp(com::Utf8Str &aHelp) = 0;
    /** @} */

    /** @name Wrapped IRangedIntegerFormValue properties
     * @{ */
    virtual HRESULT getSuffix(com::Utf8Str &aSuffix) = 0;
    virtual HRESULT getMinimum(LONG *aMinimum) = 0;
    virtual HRESULT getMaximum(LONG *aMaximum) = 0;
    /** @} */

    /** @name Wrapped IFormValue methods
     * @{ */
    /** @} */

    /** @name Wrapped IRangedIntegerFormValue methods
     * @{ */
    virtual HRESULT getInteger(LONG *aValue) = 0;
    virtual HRESULT setInteger(LONG aValue,
                               ComPtr<IProgress> &aProgress) = 0;
    /** @} */

private:
    DECLARE_CLS_COPY_CTOR_ASSIGN_NOOP(RangedIntegerFormValueWrap); /* Shuts up MSC warning C4625. */

};

#endif // !RangedIntegerFormValueWrap_H_

